﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using NST.Auth.DataContracts;
using System.Data.Linq;

namespace NST.Auth.AspNetDb
{
    internal class RoleAssembler<T> where T : RoleDC, new()
    {
        internal static IList<T> AssembleContracts(EntitySet<aspnet_UsersInRole> froms)
        {
            IList<T> tos = new List<T>();

            foreach (aspnet_UsersInRole from in froms)
            {
                tos.Add(AssembleContract(from.aspnet_Role));
            }

            return tos;
        }

        internal static T AssembleContract(aspnet_Role objFrom)
        {
            T to = new T();

            to.Id = objFrom.RoleId;
            to.Name = objFrom.RoleName;
            to.Description = objFrom.Description;
            to.ApplicationId = objFrom.ApplicationId;

            if (objFrom.aspnet_Application != null)
            {
                to.ApplicationName = objFrom.aspnet_Application.ApplicationName;
            }


            return to;
        }

    }
}
