﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Web.Security;
using System.Collections.Specialized;
using System.Configuration;
using System.Configuration.Provider;
using NST.Auth.ProviderContracts;
using System.Diagnostics;
using System.Reflection;
using System.Data.Linq;
using System.Collections.Concurrent;
using System.Threading.Tasks;
using System.Threading;
using System.Runtime.Caching;
using NST.CollectionExtensions;

namespace NST.Auth.AspNetDb
{
    public sealed class AuthRoleProvider : SqlRoleProvider
    {
    //    #region Private Fields

        static string _applicationName;
        bool _writeExceptionsToEventLog;
        ConnectionStringSettings _connectionStringSettings;
        string _connectionString;
    //    bool _useNestedRoleCache;

    //    // Cache Object for 
    //    //ObjectCache _nestedRolesCache = null;
    //    //CacheItemPolicy _nestedRolesCachePolicy = new CacheItemPolicy();

    //    static volatile ConcurrentBag<NestedRole> _nestedRoles = new ConcurrentBag<NestedRole>();               
    //    //static volatile Dictionary<Guid, Guid> _nestedRoleCache = new Dictionary<Guid, Guid>();               

    //    //static volatile ParallelQuery<KeyValuePair<Guid, Guid>> _nestedRoleCache = default(ParallelQuery<KeyValuePair<Guid, Guid>>);
    //    //static volatile ConcurrentDictionary<Guid, Guid> _nestedRoleCache = new ConcurrentDictionary<Guid, Guid>();

    //    static CancellationTokenSource _ctsRoleIds = new CancellationTokenSource();
        
    //    #endregion

    //    #region Ctor

        public AuthRoleProvider()
        {
            //_useNestedRoleCache = bool.Parse(ConfigurationManager.AppSettings["UseNestedRoleCache"]);
            Debug.WriteLine("AuthRoleProvider");

        }

    //    #endregion
        
    //    //Membership      

        public override string ApplicationName
        {
            get
            {
                if(string.IsNullOrEmpty(_applicationName))
                {

                }

                return _applicationName;
            }
            set
            {
                _applicationName = value;
            }
        }

    //    public void AddUserToRoles(string userName, string[] roleNames)
    //    {
    //        Roles.AddUserToRoles(userName, roleNames);
    //    }

    //    public override void AddUsersToRoles(string[] usernames, string[] roleNames)
    //    {
    //        Roles.AddUsersToRoles(usernames, roleNames);
    //    }

    //    public override void CreateRole(string roleName)
    //    {
    //        Roles.CreateRole(roleName);
    //    }

    //    public override bool DeleteRole(string roleName, bool throwOnPopulatedRole)
    //    {
    //        return Roles.DeleteRole(roleName, throwOnPopulatedRole);
    //    }

    //    public override string[] FindUsersInRole(string roleName, string usernameToMatch)
    //    {
    //        return FindUsersInRole(roleName, usernameToMatch);
    //    }

    //    public override string[] GetAllRoles()
    //    {
    //        return Roles.GetAllRoles();
    //    }

    //    public override string[] GetRolesForUser(string username)
    //    {
    //        return Roles.GetRolesForUser(username);
    //    }

    //    public override string[] GetUsersInRole(string roleName)
    //    {
    //        string[] _users;

    //        DataLoadOptions options = new DataLoadOptions();
    //        //options.LoadWith<CMS_Br_CollectionItem_Category_Site>(ci => ci.CMS_Luapp_CollectionCategory);
    //        //options.LoadWith<CMS_Luapp_PageContentArea>(cc => cc.CMS_Lusys_Audit);
    //        //options.LoadWith<CMS_Luapp_PageContentArea>(cc => cc.CMS_Lusys_Image);

    //        try
    //        {
    //            using (AspNetDBDataContext db = new AspNetDBDataContext(ConfigurationManager.ConnectionStrings["AuthenticatorConnectionString"].ConnectionString))
    //            {
    //                db.DeferredLoadingEnabled = false;
    //                db.LoadOptions = options;

    //                _users = (from u in db.aspnet_Users
    //                          join a in db.aspnet_Applications on u.ApplicationId equals a.ApplicationId
    //                          join ur in db.aspnet_UsersInRoles on u.UserId equals ur.UserId
    //                          join r in db.aspnet_Roles on ur.RoleId equals r.RoleId
    //                          where a.ApplicationName == _applicationName && r.RoleName == roleName
    //                          select (u.UserName)).ToArray();
    //            }
    //        }
    //        catch (Exception ex)
    //        {
    //            throw new Exception(string.Format("{0}(): Exception occurred {1}. ", GetMethodName(), ex.Message));
    //        }

    //        return _users;
    //    }

    //    //
    //    // System.Configuration.Provider.ProviderBase.Initialize Method
    //    //

        public override void Initialize(string name, NameValueCollection config)
        {
            // Here you need to find a way to determine if the user is using Windows or Sql credentials.
            // Then send back how the user was authenticated
            //
            // Initialize values from web.config.
            //

            if (config == null)
                throw new ArgumentNullException("config");

            if (name == null || name.Length == 0)
                name = "AuthRoleProvider";

            if (String.IsNullOrEmpty(config["description"]))
            {
                config.Remove("description");
                config.Add("description", "N-ST Role Provider");
            }
            
            if (config["applicationName"] == null || config["applicationName"].Trim() == "")
            {
                _applicationName = System.Web.Hosting.HostingEnvironment.ApplicationVirtualPath;
            }
            else
            {
                _applicationName = config["applicationName"];
            }


            if (config["writeExceptionsToEventLog"] != null)
            {
                if (config["writeExceptionsToEventLog"].ToUpper() == "TRUE")
                {
                    _writeExceptionsToEventLog = true;
                }
            }


            //
            // Initialize OdbcConnection.
            //

            _connectionStringSettings = ConfigurationManager.ConnectionStrings[config["connectionStringName"]];

            if (_connectionStringSettings == null || _connectionStringSettings.ConnectionString.Trim() == "")
            {
                throw new ProviderException("AuthRoleProvider Connection string cannot be blank.");
            }

            _connectionString = _connectionStringSettings.ConnectionString;

            // Initialize the abstract base class.
            base.Initialize(name, config);
        }

    //    public override bool IsUserInRole(string username, string roleName)
    //    {
    //        bool _userIsInRole = false;
    //        // We've got to get the role and any roles below it and then see if the user
    //        // is part of these roles and is considered to be a part of the role.
    //        DataLoadOptions options = new DataLoadOptions();
    //        //options.LoadWith<CMS_Br_CollectionItem_Category_Site>(ci => ci.CMS_Luapp_CollectionCategory);
    //        //options.LoadWith<CMS_Luapp_PageContentArea>(cc => cc.CMS_Lusys_Audit);
    //        //options.LoadWith<CMS_Luapp_PageContentArea>(cc => cc.CMS_Lusys_Image);

    //        using (AspNetDBDataContext db = new AspNetDBDataContext(ConfigurationManager.ConnectionStrings["AuthenticatorConnectionString"].ConnectionString))
    //        {
    //            db.DeferredLoadingEnabled = false;
    //            db.LoadOptions = options;
    //            //  var latestSortId = (from s in db.CMS_Luapp_CollectionCategories
    //            //                    where s.SiteId == siteId && s.CollectionTypeId == collectionTypeId && s.ParentCategoryId == parentCategoryId && s.RecordState == 1
    //            //                    select new { sortId = s.SortId }).OrderByDescending(o => o.sortId).ToList();

    //            //if (latestSortId != null && latestSortId.Count > 0)
    //            //{
    //            //    sortId = latestSortId[0].sortId + 1;
    //            //}

    //            var userId = from uId in db.aspnet_Users
    //                         join o in db.aspnet_UsersInRoles on uId.UserId equals o.UserId
    //                         join r in db.aspnet_Roles on o.RoleId equals r.RoleId
    //                         where uId.UserName == username && r.RoleName == roleName
    //                         select (uId.UserId);

    //            // Here if the user
    //            if (userId == null || userId.Count() < 1)
    //            {
    //                var _roleIds = from rId in db.aspnet_UsersInRoles
    //                               join u in db.aspnet_Users on rId.UserId equals u.UserId
    //                               where u.UserName == username
    //                               select (rId.RoleId);

    //                var _roleId = from r in db.aspnet_Roles
    //                                where r.RoleName == roleName
    //                                select (r.RoleId);

    //                Guid requiredRoleId = (from r in db.aspnet_Roles
    //                                        where r.RoleName == roleName
    //                                        select (r.RoleId)).First();

    //                // Here we need a singleton to cache the aspnet_NestedRoles table.
    //                if (_useNestedRoleCache)
    //                {

    //                    // If the user is a part of any roles, recursively check to see if there are any trusting roles for the roles the users is in
    //                    if (_roleIds == null || _roleIds.Count() < 1)
    //                    {

    //                        if (_nestedRoles == null || _nestedRoles.Count() < 1)
    //                        {
    //                            _nestedRoles = (from rId in db.aspnet_NestedRoles
    //                                            select new NestedRole { TrustedRoleId = rId.TrustedRoleId, TrustingRoleId = rId.TrustingRoleId }).ToConcurrentBag();
    //                        }

    //                        if (_nestedRoles == null || _nestedRoles.Count() < 1)
    //                        {
    //                            _userIsInRole = false;
    //                        }
    //                        else
    //                        {


    //                            _userIsInRole = RecursiveFindRole(_roleIds, requiredRoleId);

    //                        }
    //                    }
    //                }
    //                else
    //                {
    //                    //BUG: kfrost - Have no idea if this code will generate an IN clause that will loop
    //                    // through all the TrustedRoleIds, find the TrustingRoleIds and see if they match the RequiredRoleId
    //                    //  If not, then take the trustingRoleIds and they become the TrustedRoleId and search for their
    //                    // trustingIds, if exist, do the same check until we find a match or there are no more nests.
    //                    //http://blog.wekeroad.com/blog/creating-in-queries-with-linq-to-sql/
    //                    List<Guid> _requiredRoleIds = new List<Guid>();
    //                    _requiredRoleIds.Add(requiredRoleId);

    //                    var results = from n in db.aspnet_NestedRoles
    //                                  where _requiredRoleIds.Contains(n.TrustingRoleId)
    //                                  select (n.TrustedRoleId);

    //                    if (results != null && results.Count() > 0)
    //                        _userIsInRole = true;
    //                }
    //            }
    //            else
    //            {
    //                _userIsInRole = true;
    //            }
    //        }

    //        return _userIsInRole;
    //    }


    //    public void RemoveUserFromRole(string userName, string roleName)
    //    {
    //        Roles.RemoveUserFromRole(userName, roleName);
    //    }

    //    public void RemoveUserFromRoles(string userName, string[] roleNames)
    //    {
    //        Roles.RemoveUserFromRoles(userName, roleNames);
    //    }

    //    public void RemoveUsersFromRole(string[] usernames, string roleName)
    //    {
    //        Roles.RemoveUsersFromRole(usernames, roleName);
    //    }

    //    public override void RemoveUsersFromRoles(string[] usernames, string[] roleNames)
    //    {
    //        Roles.RemoveUsersFromRoles(usernames, roleNames);
    //    }

    //    public override bool RoleExists(string roleName)
    //    {
    //        return Roles.RoleExists(roleName);
    //    }

    //    #region IAspNetRoleProvider Members

    //    public void AddUsersToRole(string applicationName, string[] userNames, string roleName)
    //    {
    //        _applicationName = applicationName;

    //        try
    //        {
    //            Roles.AddUsersToRole(userNames, roleName);
    //        }
    //        catch (Exception ex)
    //        {
    //            throw new Exception(string.Format("{0}(): Exception occurred {1}. ", GetMethodName(), ex.Message));
    //        }
    //    }

    //    public void AddUsersToRoles(string applicationName, string[] userNames, string[] roleNames)
    //    {
    //        _applicationName = applicationName;

    //        try
    //        {
    //            AddUsersToRoles(userNames, roleNames);
    //        }
    //        catch (Exception ex)
    //        {
    //            throw new Exception(string.Format("{0}(): Exception occurred {1}. ", GetMethodName(), ex.Message));
    //        }
    //    }

    //    public void AddUserToRole(string applicationName, string userName, string roleName)
    //    {
    //        _applicationName = applicationName;

    //        try
    //        {
    //            Roles.AddUserToRole(userName, roleName); 
    //        }
    //        catch (Exception ex)
    //        {
    //            throw new Exception(string.Format("{0}(): Exception occurred {1}. ", GetMethodName(), ex.Message));
    //        }
    //    }

    //    public void AddUserToRoles(string applicationName, string userName, string[] roleNames)
    //    {
    //        _applicationName = applicationName;

    //        try
    //        {
    //            AddUserToRoles(userName, roleNames);
    //        }
    //        catch (Exception ex)
    //        {
    //            throw new Exception(string.Format("{0}(): Exception occurred {1}. ", GetMethodName(), ex.Message));
    //        }
    //    }

    //    public void CreateRole(string applicationName, string roleName)
    //    {
    //        _applicationName = applicationName;

    //        try
    //        {
    //            CreateRole(roleName);
    //        }
    //        catch (Exception ex)
    //        {
    //            throw new Exception(string.Format("{0}(): Exception occurred {1}. ", GetMethodName(), ex.Message));
    //        }
    //    }

    //    public bool DeleteRole(string applicationName, string roleName, bool throwOnPopulatedRole)
    //    {
    //        _applicationName = applicationName;

    //        try
    //        {
    //            return DeleteRole(roleName, throwOnPopulatedRole);
    //        }
    //        catch (Exception ex)
    //        {
    //            throw new Exception(string.Format("{0}(): Exception occurred {1}. ", GetMethodName(), ex.Message));
    //        }
    //    }

    //    public string[] GetAllApplications()
    //    {
    //        string[] _applications;

    //        DataLoadOptions options = new DataLoadOptions();
    //        //options.LoadWith<CMS_Br_CollectionItem_Category_Site>(ci => ci.CMS_Luapp_CollectionCategory);
    //        //options.LoadWith<CMS_Luapp_PageContentArea>(cc => cc.CMS_Lusys_Audit);
    //        //options.LoadWith<CMS_Luapp_PageContentArea>(cc => cc.CMS_Lusys_Image);

    //        try
    //        {
    //            using (AspNetDBDataContext db = new AspNetDBDataContext(ConfigurationManager.ConnectionStrings["AuthenticatorConnectionString"].ConnectionString))
    //            {
    //                db.DeferredLoadingEnabled = false;
    //                db.LoadOptions = options;

    //                _applications = (from c in db.aspnet_Applications
    //                                select (c.ApplicationName)).ToArray();
    //            }
    //        }
    //        catch (Exception ex)
    //        {
    //            throw new Exception(string.Format("{0}(): Exception occurred {1}. ", GetMethodName(), ex.Message));
    //        }

    //        return _applications;
    //    }

    //    public string[] GetAllRoles(string applicationName)
    //    {
    //        _applicationName = applicationName;

    //        try
    //        {
    //            return GetAllRoles();
    //        }
    //        catch (Exception ex)
    //        {
    //            throw new Exception(string.Format("{0}(): Exception occurred {1}. ", GetMethodName(), ex.Message));
    //        }
    //    }

    //    public string[] GetRolesForUser(string applicationName, string userName)
    //    {
    //        _applicationName = applicationName;

    //        try
    //        {
    //            return GetRolesForUser(userName);
    //        }
    //        catch (Exception ex)
    //        {
    //            throw new Exception(string.Format("{0}(): Exception occurred {1}. ", GetMethodName(), ex.Message));
    //        }
    //    }

    //    public string[] GetUsersInRole(string applicationName, string roleName)
    //    {
    //        _applicationName = applicationName;
            
    //        return GetUsersInRole(roleName);
            
    //    }

    //    public bool IsRolesEnabled(string applicationName)
    //    {
    //        _applicationName = applicationName;

    //        try
    //        {
    //            return Roles.Enabled;
    //        }
    //        catch (Exception ex)
    //        {
    //            throw new Exception(string.Format("{0}(): Exception occurred {1}. ", GetMethodName(), ex.Message));
    //        }
    //    }

    //    public bool IsUserInRole(string applicationName, string userName, string role)
    //    {
    //        _applicationName = applicationName;

    //        return IsUserInRole(userName, role);
    //    }

    //    public bool RoleExists(string applicationName, string roleName)
    //    {
    //        _applicationName = applicationName;

    //        try
    //        {
    //            return RoleExists(roleName);
    //        }
    //        catch (Exception ex)
    //        {
    //            throw new Exception(string.Format("{0}(): Exception occurred {1}. ", GetMethodName(), ex.Message));
    //        }
    //    }

    //    public void RemoveUserFromRole(string applicationName, string userName, string roleName)
    //    {
    //        _applicationName = applicationName;

    //        try
    //        {
    //            RemoveUserFromRole(userName, roleName);
    //        }
    //        catch (Exception ex)
    //        {
    //            throw new Exception(string.Format("{0}(): Exception occurred {1}. ", GetMethodName(), ex.Message));
    //        }
    //    }

    //    public void RemoveUserFromRoles(string applicationName, string userName, string[] roleNames)
    //    {
    //        _applicationName = applicationName;

    //        try
    //        {
    //            RemoveUserFromRoles(userName, roleNames);
    //        }
    //        catch (Exception ex)
    //        {
    //            throw new Exception(string.Format("{0}(): Exception occurred {1}. ", GetMethodName(), ex.Message));
    //        }
    //    }

    //    public void RemoveUsersFromRole(string applicationName, string[] users, string roleName)
    //    {
    //        _applicationName = applicationName;

    //        try
    //        {
    //            RemoveUsersFromRole(users, roleName);
    //        }
    //        catch (Exception ex)
    //        {
    //            throw new Exception(string.Format("{0}(): Exception occurred {1}. ", GetMethodName(), ex.Message));
    //        }
    //    }

    //    public void RemoveUsersFromRoles(string applicationName, string[] users, string[] roleNames)
    //    {
    //        _applicationName = applicationName;

    //        try
    //        {
    //            RemoveUsersFromRoles(users, roleNames);
    //        }
    //        catch (Exception ex)
    //        {
    //            throw new Exception(string.Format("{0}(): Exception occurred {1}. ", GetMethodName(), ex.Message));
    //        }
    //    }

    //    #endregion

    //    #region aspNetDB Role Admin Methods

    //    //public bool ValidateAdminUser(string appName, string userName, string password)
    //    //{
    //    //    bool _isValid = false;

    //    //    if (!string.IsNullOrEmpty(appName))
    //    //        _applicationName = appName;

    //    //    IAuthMembershipProvider _authMembershipProvider = new AuthMembershipProvider();
    //    //    _isValid = _authMembershipProvider.ValidateUser(_applicationName, userName, password);


    //    //    return _isValid;

    //    //}

    //    /// <summary>
    //    /// Determines if a user is in a particular role or a child r
    //    /// </summary>
    //    /// <param name="appName"></param>
    //    /// <param name="userName"></param>
    //    /// <param name="role"></param>
    //    /// <returns></returns>
    //    public bool AuthorizeUser(string appName, string userName, string role)
    //    {
    //        bool _retValue = false;

    //        return _retValue;

    //    }

    //    #endregion
        
    //    #region Private Methods

    //    //private bool CachedIsUserInRole(string userName, Guid requiredRoleId)
    //    //{
    //    //    bool _isUserInRole = false;
            
    //    //        DataLoadOptions options = new DataLoadOptions();

    //    //        using (AspNetDBDataContext db = new AspNetDBDataContext(ConfigurationManager.ConnectionStrings["AuthenticatorConnectionString"].ConnectionString))
    //    //        {
    //    //            db.DeferredLoadingEnabled = false;
    //    //            db.LoadOptions = options;

    //    //            // Get all the user Roles for the user
    //    //            var _roleIds = from roles in db.aspnet_UsersInRoles
    //    //                          join o in db.aspnet_Users on roles.UserId equals o.UserId
    //    //                          where o.UserName == userName
    //    //                          select (roles.RoleId);

    //    //            // If the user is a part of any roles, recursively check to see if there are any trusting roles for the roles the users is in
    //    //            if (_roleIds == null || _roleIds.Count() < 1)
    //    //            {

    //    //                if (_nestedRoles == null || _nestedRoles.Count() < 1)
    //    //                {
    //    //                    _nestedRoles=(from rId in db.aspnet_NestedRoles
    //    //                                  select new NestedRole { TrustedRoleId = rId.TrustedRoleId, TrustingRoleId = rId.TrustingRoleId }).ToConcurrentBag();
    //    //                }

    //    //                if (_nestedRoles == null || _nestedRoles.Count() < 1)
    //    //                {
    //    //                    _isUserInRole = false;
    //    //                }
    //    //                else
    //    //                {
    //    //                    _isUserInRole = RecursiveFindRole(_roleIds, requiredRoleId);

    //    //                }
    //    //            }
    //    //        }
               

    //    //    return _isUserInRole;
    //    //}

    //    private string GetMethodName()
    //    {
    //        StackTrace st = new StackTrace();
    //        StackFrame sf = st.GetFrame(1);
    //        MethodBase mb = sf.GetMethod();

    //        return mb.Name;
    //    }

    //    private bool RecursiveFindRole(IEnumerable<Guid> userRoleIds, Guid requiredRoleId)
    //    {
    //        bool _isUserInRole = false;

    //        Parallel.ForEach(userRoleIds, currentRoleId =>
    //        {
    //            // First we find all the trustingRoles from the NestedRoles table for the UserRoleIds passed in.
    //            var _trustingRoleIds = _nestedRoles.Where(c => c.TrustedRoleId == currentRoleId).Select(c => c.TrustingRoleId);

    //            if (_trustingRoleIds != null && _trustingRoleIds.Count() > 0)
    //            {
    //                // See if any of these Roles have a Trusting relationship with the requiredRole
    //                 _trustingRoleIds.Contains(requiredRoleId);

    //                if (_trustingRoleIds != null)
    //                {
    //                    if(_trustingRoleIds.Contains(requiredRoleId))
    //                    {
    //                    _isUserInRole = true;
    //                    return;
    //                    }
    //                    else
    //                    {
    //                        _isUserInRole = RecursiveFindRole(_trustingRoleIds, requiredRoleId);
    //                        // Recursion here to go to the end of each Role Children till we reach the end or find
    //                        // the requiredRole
    //                    }
    //                }
                    
    //            }

    //        });
            

    //        return _isUserInRole;
    //    }

    //    #endregion



        public override void AddUsersToRoles(string[] usernames, string[] roleNames)
        {
            base.AddUsersToRoles(usernames, roleNames);
        }

        public override void CreateRole(string roleName)
        {
            base.CreateRole(roleName);
        }

        public override bool DeleteRole(string roleName, bool throwOnPopulatedRole)
        {
            throw new NotImplementedException();
        }

        public override string[] FindUsersInRole(string roleName, string usernameToMatch)
        {
            throw new NotImplementedException();
        }

        public override string[] GetAllRoles()
        {
            throw new NotImplementedException();
        }

        public override string[] GetRolesForUser(string username)
        {            
            return base.GetRolesForUser(username);
        }

        public override string[] GetUsersInRole(string roleName)
        {
            throw new NotImplementedException();
        }

        public override bool IsUserInRole(string username, string roleName)
        {
            throw new NotImplementedException();
        }

        public override void RemoveUsersFromRoles(string[] usernames, string[] roleNames)
        {
            base.RemoveUsersFromRoles(usernames, roleNames);
        }

        public override bool RoleExists(string roleName)
        {
            throw new NotImplementedException();
        }
    }
}
