﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ServiceModel;
using System.Net.Security;
using NST.Auth.MessageContracts;
using NST.Auth.DataContracts;
using System.Web.Security;

namespace NST.Auth.ProviderContracts
{    
    public interface IAuthenticatorProvider
    {
        Guid CreateUpdateApplication(ApplicationDC obj);
        Guid CreateUpdateRole(RoleDC obj);
        //MembershipCreateStatus CreateUser(NewUserDC obj);
        void DeleteApplications(IList<string> applicationNames);
        void DeleteRoles(string applicationName, IList<string> roleNames);
        void DeleteUsers(string applicationName, IList<string> userNames);
        IList<ApplicationDC> GetApplications();
        IList<RoleDC> GetRoles(IList<string> roleNames, string appName, Guid? appId, string userName);
        IList<UserInfoDC> GetUsers(string appName, string roleName);
        MembershipCreateStatus AddUpdateUser(UserInfoDC obj);

    }
}
