﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ServiceModel;
using System.Net.Security;

namespace NST.Auth.ServiceContracts
{
    [ServiceContract(Namespace = "http://n-stech.com/AspNetRoleService/2010/05", Name = "IAuthRoleService", SessionMode = SessionMode.Allowed, ProtectionLevel = ProtectionLevel.None)]
    public interface IAuthRoleService
    {
        [OperationContractAttribute(Action = "AddUsersToRoleByApp", IsOneWay = false, AsyncPattern = false, IsTerminating = false, IsInitiating = true, Name = "AddUsersToRoleByApp")]
        void AddUsersToRoleByApp(string applicationName, string[] userNames, string role);

        [OperationContractAttribute(Action = "AddUsersToRolesByApp", IsOneWay = false, AsyncPattern = false, IsTerminating = false, IsInitiating = true, Name = "AddUsersToRolesByApp")]
        void AddUsersToRolesByApp(string applicationName, string[] userNames, string[] roles);

        [OperationContractAttribute(Action = "AddUserToRoleByApp", IsOneWay = false, AsyncPattern = false, IsTerminating = false, IsInitiating = true, Name = "AddUserToRoleByApp")]
        void AddUserToRoleByApp(string applicationName, string userName, string role);

        [OperationContractAttribute(Action = "AddUserToRolesByApp", IsOneWay = false, AsyncPattern = false, IsTerminating = false, IsInitiating = true, Name = "AddUserToRolesByApp")]
        void AddUserToRolesByApp(string applicationName, string userName, string[] roles);

        [OperationContractAttribute(Action = "CreateRoleByApp", IsOneWay = false, AsyncPattern = false, IsTerminating = false, IsInitiating = true, Name = "CreateRoleByApp")]
        void CreateRoleByApp(string applicationName, string role);

        [OperationContractAttribute(Action = "DeleteRoleByApp", IsOneWay = false, AsyncPattern = false, IsTerminating = false, IsInitiating = true, Name = "DeleteRoleByApp")]
        bool DeleteRoleByApp(string applicationName, string role, bool throwOnPopulatedRole);

        [OperationContractAttribute(Action = "GetAllApplications", IsOneWay = false, AsyncPattern = false, IsTerminating = false, IsInitiating = true, Name = "GetAllApplications")]
        string[] GetAllApplications();

        [OperationContractAttribute(Action = "GetAllRolesByApp", IsOneWay = false, AsyncPattern = false, IsTerminating = false, IsInitiating = true, Name = "GetAllRolesByApp")]
        string[] GetAllRolesByApp(string applicationName);

        [OperationContractAttribute(Action = "GetRolesForUserByApp", IsOneWay = false, AsyncPattern = false, IsTerminating = false, IsInitiating = true, Name = "GetRolesForUserByApp")]
        string[] GetRolesForUserByApp(string applicationName, string userName);

        [OperationContractAttribute(Action = "GetUsersInRoleByApp", IsOneWay = false, AsyncPattern = false, IsTerminating = false, IsInitiating = true, Name = "GetUsersInRoleByApp")]
        string[] GetUsersInRoleByApp(string applicationName, string role);

        [OperationContractAttribute(Action = "IsRolesEnabledByApp", IsOneWay = false, AsyncPattern = false, IsTerminating = false, IsInitiating = true, Name = "IsRolesEnabledByApp")]
        bool IsRolesEnabledByApp(string applicationName);

        [OperationContractAttribute(Action = "RoleExistsByApp", IsOneWay = false, AsyncPattern = false, IsTerminating = false, IsInitiating = true, Name = "RoleExistsByApp")]
        bool RoleExistsByApp(string applicationName, string role);

        [OperationContractAttribute(Action = "RemoveUserFromRoleByApp", IsOneWay = false, AsyncPattern = false, IsTerminating = false, IsInitiating = true, Name = "RemoveUserFromRoleByApp")]
        void RemoveUserFromRoleByApp(string applicationName, string userName, string roleName);

        [OperationContractAttribute(Action = "RemoveUserFromRolesByApp", IsOneWay = false, AsyncPattern = false, IsTerminating = false, IsInitiating = true, Name = "RemoveUserFromRolesByApp")]
        void RemoveUserFromRolesByApp(string applicationName, string userName, string[] roles);

        [OperationContractAttribute(Action = "RemoveUsersFromRoleByApp", IsOneWay = false, AsyncPattern = false, IsTerminating = false, IsInitiating = true, Name = "RemoveUsersFromRoleByApp")]
        void RemoveUsersFromRoleByApp(string applicationName, string[] users, string role);

        [OperationContractAttribute(Action = "RemoveUsersFromRolesByApp", IsOneWay = false, AsyncPattern = false, IsTerminating = false, IsInitiating = true, Name = "RemoveUsersFromRolesByApp")]
        void RemoveUsersFromRolesByApp(string applicationName, string[] users, string[] roles);

        [OperationContractAttribute(Action = "AddUsersToRole", IsOneWay = false, AsyncPattern = false, IsTerminating = false, IsInitiating = true, Name = "AddUsersToRole")]
        void AddUsersToRole(string[] userNames, string role);

        [OperationContractAttribute(Action = "AddUsersToRoles", IsOneWay = false, AsyncPattern = false, IsTerminating = false, IsInitiating = true, Name = "AddUsersToRoles")]
        void AddUsersToRoles(string[] userNames, string[] roles);

        [OperationContractAttribute(Action = "AddUserToRole", IsOneWay = false, AsyncPattern = false, IsTerminating = false, IsInitiating = true, Name = "AddUserToRole")]
        void AddUserToRole(string userName, string role);

        [OperationContractAttribute(Action = "AddUserToRoles", IsOneWay = false, AsyncPattern = false, IsTerminating = false, IsInitiating = true, Name = "AddUserToRoles")]
        void AddUserToRoles(string userName, string[] roles);

        [OperationContractAttribute(Action = "CreateRole", IsOneWay = false, AsyncPattern = false, IsTerminating = false, IsInitiating = true, Name = "CreateRole")]
        void CreateRole(string role);

        [OperationContractAttribute(Action = "DeleteRole", IsOneWay = false, AsyncPattern = false, IsTerminating = false, IsInitiating = true, Name = "DeleteRole")]
        bool DeleteRole(string role, bool throwOnPopulatedRole);

        [OperationContractAttribute(Action = "GetAllRoles", IsOneWay = false, AsyncPattern = false, IsTerminating = false, IsInitiating = true, Name = "GetAllRoles")]
        string[] GetAllRoles();

        [OperationContractAttribute(Action = "GetRolesForUser", IsOneWay = false, AsyncPattern = false, IsTerminating = false, IsInitiating = true, Name = "GetRolesForUser")]
        string[] GetRolesForUser(string userName);

        [OperationContractAttribute(Action = "GetUsersInRole", IsOneWay = false, AsyncPattern = false, IsTerminating = false, IsInitiating = true, Name = "GetUsersInRole")]
        string[] GetUsersInRole(string role);

        [OperationContractAttribute(Action = "IsRolesEnabled", IsOneWay = false, AsyncPattern = false, IsTerminating = false, IsInitiating = true, Name = "IsRolesEnabled")]
        bool IsRolesEnabled();

        [OperationContractAttribute(Action = "IsUserInRole", IsOneWay = false, AsyncPattern = false, IsTerminating = false, IsInitiating = true, Name = "IsUserInRole")]
        bool IsUserInRole(string applicationName, string userName, string role);

        [OperationContractAttribute(Action = "RoleExists", IsOneWay = false, AsyncPattern = false, IsTerminating = false, IsInitiating = true, Name = "RoleExists")]
        bool RoleExists(string role);

        [OperationContractAttribute(Action = "RemoveUserFromRole", IsOneWay = false, AsyncPattern = false, IsTerminating = false, IsInitiating = true, Name = "RemoveUserFromRole")]
        void RemoveUserFromRole(string userName, string roleName);

        [OperationContractAttribute(Action = "RemoveUserFromRoles", IsOneWay = false, AsyncPattern = false, IsTerminating = false, IsInitiating = true, Name = "RemoveUserFromRoles")]
        void RemoveUserFromRoles(string userName, string[] roles);

        [OperationContractAttribute(Action = "RemoveUsersFromRole", IsOneWay = false, AsyncPattern = false, IsTerminating = false, IsInitiating = true, Name = "RemoveUsersFromRole")]
        void RemoveUsersFromRole(string[] users, string role);

        [OperationContractAttribute(Action = "RemoveUsersFromRoles", IsOneWay = false, AsyncPattern = false, IsTerminating = false, IsInitiating = true, Name = "RemoveUsersFromRoles")]
        void RemoveUsersFromRoles(string[] users, string[] roles);
    }
}
