﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ServiceModel.Dispatcher;
using System.Security.Principal;
using System.ServiceModel.Channels;
using System.ServiceModel;
using System.Web;
using System.Threading;
using System.ServiceModel.Description;
using System.Collections.ObjectModel;

namespace NST.Auth.ServiceImplementation
{
    public class UseFormsAuthentication : IDispatchMessageInspector
    {
        public UseFormsAuthentication()
        {

        }

        #region IDispatchMessageInspector Members

        public object AfterReceiveRequest(ref Message request, IClientChannel channel, InstanceContext instanceContext)
        {
            IPrincipal currentUser = HttpContext.Current.User;

            if ((currentUser is System.Web.Security.RolePrincipal) && (currentUser != Thread.CurrentPrincipal)) Thread.CurrentPrincipal = currentUser;

            return null;
        }

        public void BeforeSendReply(ref Message reply, object correlationState)
        {

        }



        #endregion
    }

    [AttributeUsage(AttributeTargets.Class)]
    public class UseFormsAuthenticationBehaviorAttribute : Attribute, IServiceBehavior
    {
        #region IServiceBehavior Members

        public void AddBindingParameters(ServiceDescription serviceDescription, ServiceHostBase serviceHostBase, Collection<ServiceEndpoint> endpoints, BindingParameterCollection bindingParameters)
        {

        }

        public void ApplyDispatchBehavior(ServiceDescription serviceDescription, ServiceHostBase serviceHostBase)
        {
            foreach (ChannelDispatcher channelDispatch in serviceHostBase.ChannelDispatchers)
            {
                foreach (EndpointDispatcher endpointDispatch in channelDispatch.Endpoints)
                {
                    endpointDispatch.DispatchRuntime.MessageInspectors.Add(new UseFormsAuthentication());
                }
            }
        }

        public void Validate(ServiceDescription serviceDescription, ServiceHostBase serviceHostBase)
        {

        }

        #endregion

    }
}
